Name:		Topologic
Version:	8.0.2
Release:	1%{?dist}
Summary:	Logical, hierarchical and topological representation of spaces and entities
License:	AGPL-3.0-or-later
URL:		https://github.com/wassimj/Topologic/
# https://github.com/wassimj/Topologic/archive/refs/heads/main.zip
Source0:	Topologic-main.zip
BuildRequires:	cmake gcc-c++ opencascade-devel libuuid-devel dos2unix
BuildRequires:	python3-devel
BuildRequires:	pybind11-devel

%description
Topologic is a software modeling library enabling hierarchical and topological
representations of architectural spaces, buildings and artifacts through
non-manifold topology.

%package devel
Summary:	Development headers for linking to the TopologicCore library
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}
Requires:	opencascade-devel libuuid-devel

%package python3
Summary:	A python module for the TopologicCore BIM library
Requires:	%{name} = %{version}-%{release}

%description devel
The Topologic-devel package includes the header files necessary for
developing programs which will use the TopologicCore library.

%description python3
A python module for the TopologicCore BIM library

%prep

%autosetup -n Topologic-main

dos2unix README.md

# upstream imports pybind11 as a submodule
sed -i 's/add_subdirectory(pybind11)/find_package(pybind11 REQUIRED)/' \
    TopologicPythonBindings/CMakeLists.txt

%build

%cmake -DCMAKE_SKIP_RPATH=ON
%cmake_build

%install
# do a manual install

mkdir -p $RPM_BUILD_ROOT/%{_libdir}
cp -a *-linux-*/TopologicCore/libTopologicCore.so* \
    $RPM_BUILD_ROOT/%{_libdir}/

mkdir -p $RPM_BUILD_ROOT/%{python3_sitearch}
cp -a *-linux-*/TopologicPythonBindings/topologic_core.cpython*.so \
    $RPM_BUILD_ROOT/%{python3_sitearch}/

mkdir -p $RPM_BUILD_ROOT/%{_includedir}
cp -a TopologicCore/include \
    $RPM_BUILD_ROOT/%{_includedir}/TopologicCore

%files
%doc README.md
%{_libdir}/libTopologicCore.so.*

%files python3
%doc README.md
%{python3_sitearch}/*

%files devel
%doc README.md
%{_includedir}/TopologicCore
%{_libdir}/libTopologicCore.so

%changelog
* Sun Dec 01 2024 Bruno Postle <bruno@postle.net> - 8.0.2-1
- release

* Mon Sep 02 2024 Bruno Postle <bruno@postle.net> - 6.0.3-1
- release, python library is now topologic_core

* Wed Oct 11 2023 Bruno Postle <bruno@postle.net> - 0.0-0.20231011git
- git snapshot

* Sat Sep 23 2023 Bruno Postle <bruno@postle.net> - 0.0-0.20230923git
- git snapshot, all new CMake build

* Sat Feb 18 2023 Bruno Postle <bruno@postle.net> - 0.0-0.20230218git
- git snapshot, all new CMake build

* Wed Jan 25 2023 Bruno Postle <bruno@postle.net> - 0.0-0.20230125git
- git snapshot, rebuild for new opencascade 7.6.3

* Sat Dec 10 2022 Bruno Postle <bruno@postle.net> - 0.0-0.20221210git
- git snapshot
- revert to system pybind11 as f37 ships with 2.10.1

* Sun Nov 13 2022 Bruno Postle <bruno@postle.net> - 0.0-0.20221113git
- git snapshot
- use bundled pybind11 as f36/pybind11-2.9.2 is ok but f37/pybind11-2.10.0 is not

* Mon Jan 31 2022 Bruno Postle <bruno@postle.net> - 0.0-0.20220131git
- git snapshot (NoGlobalCluster branch is merged)

* Wed Jan 19 2022 Bruno Postle <bruno@postle.net> - 0.0-0.20220119git
- git snapshot of NoGlobalCluster branch

* Mon Jan 17 2022 Bruno Postle <bruno@postle.net> - 0.0-0.20220117git
- git snapshot + 2nd patch to remove GlobalCluster + patch for CellComplex.ByFaces()

* Sat Jan 08 2022 Bruno Postle <bruno@postle.net> - 0.0-0.20220108git
- git snapshot + patch to remove GlobalCluster + patch for CellComplex.ByFaces()

* Thu Jan 06 2022 Bruno Postle <bruno@postle.net> - 0.0-0.20220106git
- git snapshot + patch to remove GlobalCluster

* Tue Jan 04 2022 Bruno Postle <bruno@postle.net> - 0.0-0.20220104git
- git snapshot + linux cmake patch

* Sun Jan 02 2022 Bruno Postle <bruno@postle.net> - 0.0-0.20220102git
- git snapshot + range-loop-construct warning fixes

* Thu Oct 28 2021 Bruno Postle <bruno@postle.net> - 0.0-0.20211028git
- upstream, build c++ and python

* Mon Oct 18 2021 Bruno Postle <bruno@postle.net> - 0.0-0.20211018git
- git snapshot, new repository

* Sat Mar 06 2021 Bruno Postle <bruno@postle.net> - 0.0-0.20210306git
- git snapshot

* Wed Jan 20 2021 Bruno Postle <bruno@postle.net> - 0.0-0.20210120git
- git snapshot

* Wed Jan 06 2021 Bruno Postle <bruno@postle.net> - 0.0-0.20210106git
- git snapshot
